package com.example.bobby.test;

import com.vaadin.Application;
import com.vaadin.terminal.gwt.server.AbstractApplicationServlet;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Window;

import java.util.logging.Logger;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServletRequest;

public class CounterApplication extends Application {

    // simple counter that is incremented whenever someone clicks the button
    private int counter = 0;

    // this label shows the value of the counter
    private Label countLabel = new Label(String.valueOf(counter));

    @Override
    public void init() {
        Window window = new Window("Counter test app");
        window.addComponent(countLabel);
        window.addComponent(new Button("Click Me",
            new Button.ClickListener() {
                @Override
                public void buttonClick(Button.ClickEvent event) {
                    countLabel.setValue(++counter);
		    Logger.getLogger("bobby").info(
		        "Counter: " + counter);
                }
            }));
        setMainWindow(window);
    }

    // This is the servlet that loads the application above.
    @WebServlet(urlPatterns = {"/*"})
    public static class LoaderServlet extends AbstractApplicationServlet {

        @Override
        protected Application getNewApplication(HttpServletRequest request)
            throws ServletException {

            return new CounterApplication();
        }

        @Override
        protected Class<? extends Application> getApplicationClass()
            throws ClassNotFoundException {

            return CounterApplication.class;
        }
    }
}
